<?php
/**
 * UsersController
 *
 */
class UsersController extends AppController {

    public $components = array('Openid');
    public $uses = array();

    /**
     * 許可するOpenID
     *
     */
    protected $provider_list = array(
            'http://mixi.jp/',
    );


    /**
     * login()
     *
     */
    public function login()
    {
        $response = $this->getRequest();
        if ($response) {

	    $nickname = $response->getSigned('http://openid.net/extensions/sreg/1.1', 'nickname');

            $provider_url = dirname(trim($response->identity_url, '/')) . '/';

            //登録されているOpenIDユーザならニックネーム登録
            $this->Session->write('name', $nickname);
            $this->Session->write('provider_url', $provider_url);
            $this->Session->write('identity_url', $response->identity_url);

            $this->redirect('/articles/index');
        }
    }

    private function setMessage($message) {
        $this->set('message', $message);
    }

    /**
     * getRequest
     *
     */
    protected function getRequest()
    {
        $returnTo = 'http://'.$_SERVER['HTTP_HOST'] . $this->here;
        if (!empty($this->data)) {
            try {
                if (!in_array($this->data['OpenidUrl']['provider_url'], $this->provider_list)) {
                    throw new Exception('不正なプロバイダURLです');
                }
                $login_url = $this->data['OpenidUrl']['provider_url'];
                if (!empty($this->data['OpenidUrl']['username'])) {
                    $login_url .= $this->data['OpenidUrl']['username'] . '/';
                }
                $this->Openid->authenticate(
                    $login_url,
                    $returnTo,
                    'http://'.$_SERVER['HTTP_HOST'],
                    array(),
                    array('nickname')
                );
            } catch (InvalidArgumentException $e) {
                $this->setMessage('Invalid OpenID');
            } catch (Exception $e) {
                $this->setMessage($e->getMessage());
            }
        } elseif (count($_GET) > 1) {
            $response = $this->Openid->getResponse($returnTo);

            if ($response->status == Auth_OpenID_CANCEL) {
                $this->setMessage('Verification cancelled');
            } elseif ($response->status == Auth_OpenID_FAILURE) {
                $this->setMessage('OpenID verification failed: '.$response->message);
            } elseif ($response->status == Auth_OpenID_SUCCESS) {
                $this->setMessage('successfully authenticated!');
                return $response;
            }
        }

        return false;
    }

    /**
     * userlogout
     *
     */
    function userlogout()
    {
        $this->Session->setFlash('ログアウトしました');
        $this->Session->destroy();
        $this->redirect('/articles/index');
    }

}
?>
